#include "CGame.h"

void CGame::Initialize()
{
    SetupGPUProgram();
    SetupVAO();
}

void CGame::Shutdown()
{
    
}

void CGame::OnResize(int width, int height)
{
    glViewport(0, 0, width, height);
}

void CGame::Render()
{
    glClearColor(0.2f, 0.2f, 0.2f, 1.0f);
    glClear(GL_COLOR_BUFFER_BIT);

    m_pShader->use();
    glBindVertexArray(m_VBO);
    glDrawArrays(GL_TRIANGLES, 0, 3);
}

void CGame::SetupVAO()
{
    float vertices[] = {
        -0.5f, -0.5f, 0.0f,
        0.5f, -0.5f, 0.0f,
        0.0f,  0.5f, 0.0f
    };

    glGenBuffers(1, &m_VBO);

    glGenVertexArrays(1, &m_VAO);
    glBindVertexArray(m_VAO);
    glBindBuffer(GL_ARRAY_BUFFER, m_VBO);
    glBufferData(GL_ARRAY_BUFFER, sizeof(vertices), vertices, GL_STATIC_DRAW);
    glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, 3 * sizeof(float), (void*)0);
    glEnableVertexAttribArray(0);
}

void CGame::SetupGPUProgram()
{
    m_pShader = new Shader("vertex.glsl", "fragment.glsl");
}